Add per arch mrr daily test for denverton platform
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2019 Cisco and/or its affiliates.
2 # Copyright (c) 2019 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45
46     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
47     case_text="${NODENESS}_${FLAVOR}"
48     case "${case_text}" in
49         "1n_skx" | "1n_tx2")
50             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
51             # script's functions. Env variables are read from ssh output
52             # back to localhost for further processing.
53             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
54             ssh="ssh root@${hostname} -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # backtics to avoid https://midnight-commander.org/ticket/2142
57             env_vars=`${ssh} "$(declare -f); ${run}"` || {
58                 die "Topology reservation via shim-dcr failed!"
59             }
60             set -a
61             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
62                 die "Source failed!"
63             }
64             set +a
65             ;;
66         "1n_vbox")
67             # We execute reservation on localhost. Sourced script automatially
68             # sets environment variables for further processing.
69             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
70             ;;
71         *)
72             die "Unknown specification: ${case_text}!"
73     esac
74
75     trap 'deactivate_docker_topology' EXIT || {
76          die "Trap attempt failed, please cleanup manually. Aborting!"
77     }
78
79     # Replace all variables in template with those in environment.
80     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
81         die "Topology file create failed!"
82     }
83
84     WORKING_TOPOLOGY="/tmp/topology.yaml"
85     mv topo.yml "${WORKING_TOPOLOGY}" || {
86         die "Topology move failed!"
87     }
88     cat ${WORKING_TOPOLOGY} | grep -v password || {
89         die "Topology read failed!"
90     }
91 }
92
93
94 function activate_virtualenv () {
95
96     # Update virtualenv pip package, delete and create virtualenv directory,
97     # activate the virtualenv, install requirements, set PYTHONPATH.
98
99     # Arguments:
100     # - ${1} - Path to existing directory for creating virtualenv in.
101     #          If missing or empty, ${CSIT_DIR} is used.
102     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
103     # Variables read:
104     # - CSIT_DIR - Path to existing root of local CSIT git repository.
105     # Variables exported:
106     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
107     # Functions called:
108     # - die - Print to stderr and exit.
109
110     set -exuo pipefail
111
112     root_path="${1-$CSIT_DIR}"
113     env_dir="${root_path}/env"
114     req_path=${2-$CSIT_DIR/requirements.txt}
115     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
116     pip install --upgrade virtualenv || {
117         die "Virtualenv package install failed."
118     }
119     virtualenv "${env_dir}" || {
120         die "Virtualenv creation failed."
121     }
122     set +u
123     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
124     set -u
125     pip install --upgrade -r "${req_path}" || {
126         die "Requirements installation failed."
127     }
128     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
129     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
130 }
131
132
133 function archive_tests () {
134
135     # Create .tar.xz of generated/tests for archiving.
136     # To be run after generate_tests, kept separate to offer more flexibility.
137
138     # Directory read:
139     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
140     # File rewriten:
141     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
142
143     set -exuo pipefail
144
145     tar c "${GENERATED_DIR}/tests" | xz -9e > "${ARCHIVE_DIR}/tests.tar.xz" || {
146         die "Error creating archive of generated tests."
147     }
148 }
149
150
151 function check_download_dir () {
152
153     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
154     #
155     # Variables read:
156     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
157     # Directories read:
158     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
159     # Functions called:
160     # - die - Print to stderr and exit.
161
162     set -exuo pipefail
163
164     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
165         die "No artifacts downloaded!"
166     fi
167 }
168
169
170 function cleanup_topo () {
171
172     # Variables read:
173     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
174     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
175
176     set -exuo pipefail
177
178     python "${PYTHON_SCRIPTS_DIR}/topo_cleanup.py" -t "${WORKING_TOPOLOGY}"
179     # Not using "|| die" as some callers might want to ignore errors,
180     # e.g. in teardowns, such as unreserve.
181 }
182
183
184 function common_dirs () {
185
186     # Set global variables, create some directories (without touching content).
187
188     # Variables set:
189     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
190     # - CSIT_DIR - Path to existing root of local CSIT git repository.
191     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
192     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
193     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
194     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
195     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archive".
196     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
197     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
198     # Directories created if not present:
199     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
200     # Functions called:
201     # - die - Print to stderr and exit.
202
203     set -exuo pipefail
204
205     BASH_FUNCTION_DIR="$(dirname "$(readlink -e "${BASH_SOURCE[0]}")")" || {
206         die "Some error during localizing this source directory."
207     }
208     # Current working directory could be in a different repo, e.g. VPP.
209     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
210     CSIT_DIR="$(readlink -e "$(git rev-parse --show-toplevel)")" || {
211         die "Readlink or git rev-parse failed."
212     }
213     popd || die "Popd failed."
214     TOPOLOGIES_DIR="$(readlink -e "${CSIT_DIR}/topologies/available")" || {
215         die "Readlink failed."
216     }
217     RESOURCES_DIR="$(readlink -e "${CSIT_DIR}/resources")" || {
218         die "Readlink failed."
219     }
220     TOOLS_DIR="$(readlink -e "${RESOURCES_DIR}/tools")" || {
221         die "Readlink failed."
222     }
223     PYTHON_SCRIPTS_DIR="$(readlink -e "${TOOLS_DIR}/scripts")" || {
224         die "Readlink failed."
225     }
226
227     ARCHIVE_DIR="$(readlink -f "${CSIT_DIR}/archive")" || {
228         die "Readlink failed."
229     }
230     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
231     DOWNLOAD_DIR="$(readlink -f "${CSIT_DIR}/download_dir")" || {
232         die "Readlink failed."
233     }
234     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
235     GENERATED_DIR="$(readlink -f "${CSIT_DIR}/generated")" || {
236         die "Readlink failed."
237     }
238     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
239 }
240
241
242 function compose_pybot_arguments () {
243
244     # Variables read:
245     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
246     # - DUT - CSIT test/ subdirectory, set while processing tags.
247     # - TAGS - Array variable holding selected tag boolean expressions.
248     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
249     # - TEST_CODE - The test selection string from environment or argument.
250     # Variables set:
251     # - PYBOT_ARGS - String holding part of all arguments for pybot.
252     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
253
254     set -exuo pipefail
255
256     # No explicit check needed with "set -u".
257     PYBOT_ARGS=("--loglevel" "TRACE")
258     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
259
260     case "${TEST_CODE}" in
261         *"device"*)
262             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
263             ;;
264         *"func"*)
265             PYBOT_ARGS+=("--suite" "tests.${DUT}.func")
266             ;;
267         *"perf"*)
268             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
269             ;;
270         *)
271             die "Unknown specification: ${TEST_CODE}"
272     esac
273
274     EXPANDED_TAGS=()
275     for tag in "${TAGS[@]}"; do
276         if [[ ${tag} == "!"* ]]; then
277             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
278         else
279             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
280         fi
281     done
282 }
283
284
285 function copy_archives () {
286
287     # Create additional archive if workspace variable is set.
288     # This way if script is running in jenkins all will be
289     # automatically archived to logs.fd.io.
290     #
291     # Variables read:
292     # - WORKSPACE - Jenkins workspace, copy only if the value is not empty.
293     #   Can be unset, then it speeds up manual testing.
294     # - ARCHIVE_DIR - Path to directory with content to be copied.
295     # Directories updated:
296     # - ${WORKSPACE}/archives/ - Created if does not exist.
297     #   Content of ${ARCHIVE_DIR}/ is copied here.
298     # Functions called:
299     # - die - Print to stderr and exit.
300
301     set -exuo pipefail
302
303     if [[ -n "${WORKSPACE-}" ]]; then
304         mkdir -p "${WORKSPACE}/archives/" || die "Archives dir create failed."
305         cp -rf "${ARCHIVE_DIR}"/* "${WORKSPACE}/archives" || die "Copy failed."
306     fi
307 }
308
309
310 function deactivate_docker_topology () {
311
312     # Deactivate virtual vpp-device topology by removing containers.
313     #
314     # Variables read:
315     # - NODENESS - Node multiplicity of desired testbed.
316     # - FLAVOR - Node flavor string, usually describing the processor.
317
318     set -exuo pipefail
319
320     case_text="${NODENESS}_${FLAVOR}"
321     case "${case_text}" in
322         "1n_skx" | "1n_tx2")
323             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
324             ssh="ssh root@${hostname} -p 6022"
325             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
326             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
327                 die "Topology cleanup via shim-dcr failed!"
328             }
329             ;;
330         "1n_vbox")
331             enter_mutex || die
332             clean_environment || {
333                 die "Topology cleanup locally failed!"
334             }
335             exit_mutex || die
336             ;;
337         *)
338             die "Unknown specification: ${case_text}!"
339     esac
340 }
341
342
343 function die () {
344
345     # Print the message to standard error end exit with error code specified
346     # by the second argument.
347     #
348     # Hardcoded values:
349     # - The default error message.
350     # Arguments:
351     # - ${1} - The whole error message, be sure to quote. Optional
352     # - ${2} - the code to exit with, default: 1.
353
354     set -x
355     set +eu
356     warn "${1:-Unspecified run-time error occurred!}"
357     exit "${2:-1}"
358 }
359
360
361 function die_on_pybot_error () {
362
363     # Source this fragment if you want to abort on any failed test case.
364     #
365     # Variables read:
366     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
367     # Functions called:
368     # - die - Print to stderr and exit.
369
370     set -exuo pipefail
371
372     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
373         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
374     fi
375 }
376
377
378 function generate_tests () {
379
380     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
381     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
382     # The generation is done by executing any *.py executable
383     # within any subdirectory after copying.
384
385     # This is a separate function, because this code is called
386     # both by autogen checker and entries calling run_pybot.
387
388     # Directories read:
389     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
390     # Directories replaced:
391     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
392
393     set -exuo pipefail
394
395     rm -rf "${GENERATED_DIR}/tests" || die
396     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
397     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
398     cmd_line+=("-executable" "-name" "*.py")
399     file_list=$("${cmd_line[@]}") || die
400
401     for gen in ${file_list}; do
402         directory="$(dirname "${gen}")" || die
403         filename="$(basename "${gen}")" || die
404         pushd "${directory}" || die
405         ./"${filename}" || die
406         popd || die
407     done
408 }
409
410
411 function get_test_code () {
412
413     # Arguments:
414     # - ${1} - Optional, argument of entry script (or empty as unset).
415     #   Test code value to override job name from environment.
416     # Variables read:
417     # - JOB_NAME - String affecting test selection, default if not argument.
418     # Variables set:
419     # - TEST_CODE - The test selection string from environment or argument.
420     # - NODENESS - Node multiplicity of desired testbed.
421     # - FLAVOR - Node flavor string, usually describing the processor.
422
423     set -exuo pipefail
424
425     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
426     if [[ -z "${TEST_CODE}" ]]; then
427         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
428     fi
429
430     case "${TEST_CODE}" in
431         *"1n-vbox"*)
432             NODENESS="1n"
433             FLAVOR="vbox"
434             ;;
435         *"1n-skx"*)
436             NODENESS="1n"
437             FLAVOR="skx"
438             ;;
439        *"1n-tx2"*)
440             NODENESS="1n"
441             FLAVOR="tx2"
442             ;;
443         *"2n-skx"*)
444             NODENESS="2n"
445             FLAVOR="skx"
446             ;;
447         *"3n-skx"*)
448             NODENESS="3n"
449             FLAVOR="skx"
450             ;;
451         *"2n-dnv"*)
452             NODENESS="2n"
453             FLAVOR="dnv"
454             ;;
455         *"3n-dnv"*)
456             NODENESS="3n"
457             FLAVOR="dnv"
458             ;;
459         *"3n-tsh"*)
460             NODENESS="3n"
461             FLAVOR="tsh"
462             ;;
463         *)
464             # Fallback to 3-node Haswell by default (backward compatibility)
465             NODENESS="3n"
466             FLAVOR="hsw"
467             ;;
468     esac
469 }
470
471
472 function get_test_tag_string () {
473
474     # Variables read:
475     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
476     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
477     # - TEST_CODE - The test selection string from environment or argument.
478     # Variables set:
479     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
480     #   May be empty, not set on event types not adding comment.
481
482     # TODO: ci-management scripts no longer need to perform this.
483
484     set -exuo pipefail
485
486     trigger=""
487     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
488         case "${TEST_CODE}" in
489             *"device"*)
490                 # On parsing error, ${trigger} stays empty.
491                 trigger="$(echo "${GERRIT_EVENT_COMMENT_TEXT}" \
492                     | grep -oE '(devicetest$|devicetest[[:space:]].+$)')" \
493                     || true
494                 # Set test tags as string.
495                 TEST_TAG_STRING="${trigger#$"devicetest"}"
496                 ;;
497             *"perf"*)
498                 # On parsing error, ${trigger} stays empty.
499                 comment="${GERRIT_EVENT_COMMENT_TEXT}"
500                 # As "perftest" can be followed by something, we substitute it.
501                 comment="${comment/perftest-2n/perftest}"
502                 comment="${comment/perftest-3n/perftest}"
503                 comment="${comment/perftest-hsw/perftest}"
504                 comment="${comment/perftest-skx/perftest}"
505                 comment="${comment/perftest-dnv/perftest}"
506                 comment="${comment/perftest-tsh/perftest}"
507                 tag_string="$(echo "${comment}" \
508                     | grep -oE '(perftest$|perftest[[:space:]].+$)' || true)"
509                 # Set test tags as string.
510                 TEST_TAG_STRING="${tag_string#$"perftest"}"
511                 ;;
512             *)
513                 die "Unknown specification: ${TEST_CODE}"
514         esac
515     fi
516 }
517
518
519 function reserve_and_cleanup_testbed () {
520
521     # Reserve physical testbed, perform cleanup, register trap to unreserve.
522     # When cleanup fails, remove from topologies and keep retrying
523     # until all topologies are removed.
524     #
525     # Variables read:
526     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
527     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
528     # - BUILD_TAG - Any string suitable as filename, identifying
529     #   test run executing this function. May be unset.
530     # - BUILD_URL - Any string suitable as URL, identifying
531     #   test run executing this function. May be unset.
532     # Variables set:
533     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
534     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
535     # Functions called:
536     # - die - Print to stderr and exit.
537     # Traps registered:
538     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
539
540     set -exuo pipefail
541
542     while [[ ${TOPOLOGIES[@]} ]]; do
543         for topo in "${TOPOLOGIES[@]}"; do
544             set +e
545             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
546             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
547             opts+=("-u" "${BUILD_URL:-Unknown}")
548             python "${scrpt}" "${opts[@]}"
549             result="$?"
550             set -e
551             if [[ "${result}" == "0" ]]; then
552                 # Trap unreservation before cleanup check,
553                 # so multiple jobs showing failed cleanup improve chances
554                 # of humans to notice and fix.
555                 WORKING_TOPOLOGY="${topo}"
556                 echo "Reserved: ${WORKING_TOPOLOGY}"
557                 trap "untrap_and_unreserve_testbed" EXIT || {
558                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
559                     untrap_and_unreserve_testbed "${message}" || {
560                         die "Teardown should have died, not failed."
561                     }
562                     die "Trap attempt failed, unreserve succeeded. Aborting."
563                 }
564                 # Cleanup check.
565                 set +e
566                 cleanup_topo
567                 result="$?"
568                 set -e
569                 if [[ "${result}" == "0" ]]; then
570                     break
571                 fi
572                 warn "Testbed cleanup failed: ${topo}"
573                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
574                 # WORKING_TOPOLOGY is now empty again.
575                 # Build new topology array.
576                 #   TOPOLOGIES=("${TOPOLOGIES[@]/$topo}")
577                 # does not really work, see:
578                 # https://stackoverflow.com/questions/16860877/remove-an-element-from-a-bash-array
579                 new_topologies=()
580                 for item in "${TOPOLOGIES[@]}"; do
581                     if [[ "${item}" != "${topo}" ]]; then
582                         new_topologies+=("${item}")
583                     fi
584                 done
585                 TOPOLOGIES=("${new_topologies[@]}")
586                 break
587             fi
588         done
589
590         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
591             # Exit the infinite while loop if we made a reservation.
592             break
593         fi
594
595         # Wait ~3minutes before next try.
596         sleep_time="$[ ( $RANDOM % 20 ) + 180 ]s" || {
597             die "Sleep time calculation failed."
598         }
599         echo "Sleeping ${sleep_time}"
600         sleep "${sleep_time}" || die "Sleep failed."
601     done
602     if [[ ${TOPOLOGIES[@]} ]]; then
603         echo "Reservation and cleanup successful."
604     else
605         die "Run out of operational testbeds!"
606     fi
607 }
608
609
610 function run_pybot () {
611
612     # Run pybot with options based on input variables. Create output_info.xml
613     #
614     # Variables read:
615     # - CSIT_DIR - Path to existing root of local CSIT git repository.
616     # - ARCHIVE_DIR - Path to store robot result files in.
617     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
618     # - GENERATED_DIR - Tests are assumed to be generated under there.
619     # Variables set:
620     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
621     # Functions called:
622     # - die - Print to stderr and exit.
623
624     set -exuo pipefail
625
626     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
627     all_options+=("--noncritical" "EXPECTED_FAILING")
628     all_options+=("${EXPANDED_TAGS[@]}")
629
630     pushd "${CSIT_DIR}" || die "Change directory operation failed."
631     set +e
632     pybot "${all_options[@]}" "${GENERATED_DIR}/tests/"
633     PYBOT_EXIT_STATUS="$?"
634     set -e
635
636     # Generate INFO level output_info.xml for post-processing.
637     all_options=("--loglevel" "INFO")
638     all_options+=("--log" "none")
639     all_options+=("--report" "none")
640     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
641     all_options+=("${ARCHIVE_DIR}/output.xml")
642     rebot "${all_options[@]}" || true
643     popd || die "Change directory operation failed."
644 }
645
646
647 function select_tags () {
648
649     # Variables read:
650     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
651     # - TEST_CODE - String affecting test selection, usually jenkins job name.
652     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
653     #   Can be unset.
654     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
655     # - BASH_FUNCTION_DIR - Directory with input files to process.
656     # Variables set:
657     # - TAGS - Array of processed tag boolean expressions.
658
659     set -exuo pipefail
660
661     # NIC SELECTION
662     start_pattern='^  TG:'
663     end_pattern='^ \? \?[A-Za-z0-9]\+:'
664     # Remove the TG section from topology file
665     sed_command="/${start_pattern}/,/${end_pattern}/d"
666     # All topologies DUT NICs
667     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
668                 | grep -hoP "model: \K.*" | sort -u)
669     # Selected topology DUT NICs
670     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
671                | grep -hoP "model: \K.*" | sort -u)
672     # All topologies DUT NICs - Selected topology DUT NICs
673     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
674         die "Computation of excluded NICs failed."
675     }
676
677     # Select default NIC tag.
678     case "${TEST_CODE}" in
679         *"3n-dnv"* | *"2n-dnv"*)
680             default_nic="nic_intel-x553"
681             ;;
682         *"3n-tsh"*)
683             default_nic="nic_intel-x520-da2"
684             ;;
685         *)
686             default_nic="nic_intel-x710"
687             ;;
688     esac
689
690     # Tag file directory shorthand.
691     tfd="${BASH_FUNCTION_DIR}"
692     case "${TEST_CODE}" in
693         # Select specific performance tests based on jenkins job type variable.
694         *"ndrpdr-weekly"* )
695             readarray -t test_tag_array < "${tfd}/mlr-weekly.txt" || die
696             ;;
697         *"mrr-daily"* )
698             readarray -t test_tag_array < \
699                 "${tfd}/mrr-daily-${FLAVOR}.txt" || die
700             ;;
701         *"mrr-weekly"* )
702             readarray -t test_tag_array < "${tfd}/mrr-weekly.txt" || die
703             ;;
704         * )
705             if [[ -z "${TEST_TAG_STRING-}" ]]; then
706                 # If nothing is specified, we will run pre-selected tests by
707                 # following tags.
708                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
709                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
710                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
711                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
712                                 "!dot1q" "!drv_avf")
713             else
714                 # If trigger contains tags, split them into array.
715                 test_tag_array=(${TEST_TAG_STRING//:/ })
716             fi
717             ;;
718     esac
719
720     # Blacklisting certain tags per topology.
721     #
722     # Reasons for blacklisting:
723     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
724     # TODO: Add missing reasons here (if general) or where used (if specific).
725     case "${TEST_CODE}" in
726         *"2n-skx"*)
727             test_tag_array+=("!ipsechw")
728             ;;
729         *"3n-skx"*)
730             test_tag_array+=("!ipsechw")
731             # Not enough nic_intel-xxv710 to support double link tests.
732             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
733             ;;
734         *"2n-dnv"*)
735             test_tag_array+=("!ipsechw")
736             test_tag_array+=("!memif")
737             test_tag_array+=("!srv6_proxy")
738             test_tag_array+=("!vhost")
739             test_tag_array+=("!vts")
740             test_tag_array+=("!drv_avf")
741             ;;
742         *"3n-dnv"*)
743             test_tag_array+=("!memif")
744             test_tag_array+=("!srv6_proxy")
745             test_tag_array+=("!vhost")
746             test_tag_array+=("!vts")
747             test_tag_array+=("!drv_avf")
748             ;;
749         *"3n-tsh"*)
750             test_tag_array+=("!ipsechw")
751             test_tag_array+=("!memif")
752             test_tag_array+=("!srv6_proxy")
753             test_tag_array+=("!vhost")
754             test_tag_array+=("!vts")
755             ;;
756         *"3n-hsw"*)
757             # TODO: Introduce NOIOMMU version of AVF tests.
758             # TODO: Make (both) AVF tests work on Haswell,
759             # or document why (some of) it is not possible.
760             # https://github.com/FDio/vpp/blob/master/src/plugins/avf/README.md
761             test_tag_array+=("!drv_avf")
762             # All cards have access to QAT. But only one card (xl710)
763             # resides in same NUMA as QAT. Other cards must go over QPI
764             # which we do not want to even run.
765             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
766             ;;
767         *)
768             # Default to 3n-hsw due to compatibility.
769             test_tag_array+=("!drv_avf")
770             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
771             ;;
772     esac
773
774     # We will add excluded NICs.
775     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
776
777     TAGS=()
778
779     # We will prefix with perftest to prevent running other tests
780     # (e.g. Functional).
781     prefix="perftestAND"
782     set +x
783     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
784         # Automatic prefixing for VPP jobs to limit the NIC used and
785         # traffic evaluation to MRR.
786         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
787             prefix="${prefix}mrrAND"
788         else
789             prefix="${prefix}mrrAND${default_nic}AND"
790         fi
791     fi
792     for tag in "${test_tag_array[@]}"; do
793         if [[ "${tag}" == "!"* ]]; then
794             # Exclude tags are not prefixed.
795             TAGS+=("${tag}")
796         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
797             # Empty and comment lines are skipped.
798             # Other lines are normal tags, they are to be prefixed.
799             TAGS+=("${prefix}${tag}")
800         fi
801     done
802     set -x
803 }
804
805
806 function select_vpp_device_tags () {
807
808     # Variables read:
809     # - TEST_CODE - String affecting test selection, usually jenkins job name.
810     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
811     #   Can be unset.
812     # Variables set:
813     # - TAGS - Array of processed tag boolean expressions.
814
815     set -exuo pipefail
816
817     case "${TEST_CODE}" in
818         # Select specific performance tests based on jenkins job type variable.
819         * )
820             if [[ -z "${TEST_TAG_STRING-}" ]]; then
821                 # If nothing is specified, we will run pre-selected tests by
822                 # following tags. Items of array will be concatenated by OR
823                 # in Robot Framework.
824                 test_tag_array=()
825             else
826                 # If trigger contains tags, split them into array.
827                 test_tag_array=(${TEST_TAG_STRING//:/ })
828             fi
829             ;;
830     esac
831
832     TAGS=()
833
834     # We will prefix with devicetest to prevent running other tests
835     # (e.g. Functional).
836     prefix="devicetestAND"
837     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
838         # Automatic prefixing for VPP jobs to limit testing.
839         prefix="${prefix}"
840     fi
841     for tag in "${test_tag_array[@]}"; do
842         if [[ ${tag} == "!"* ]]; then
843             # Exclude tags are not prefixed.
844             TAGS+=("${tag}")
845         else
846             TAGS+=("${prefix}${tag}")
847         fi
848     done
849 }
850
851 function select_os () {
852
853     # Variables set:
854     # - VPP_VER_FILE - Name of File in CSIT dir containing vpp stable version.
855     # - IMAGE_VER_FILE - Name of File in CSIT dir containing the image name.
856     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
857
858     set -exuo pipefail
859
860     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
861         die "Get OS release failed."
862     }
863
864     case "${os_id}" in
865         "ubuntu"*)
866             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
867             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
868             PKG_SUFFIX="deb"
869             ;;
870         "centos"*)
871             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
872             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
873             PKG_SUFFIX="rpm"
874             ;;
875         *)
876             die "Unable to identify distro or os from ${OS}"
877             ;;
878     esac
879 }
880
881
882 function select_topology () {
883
884     # Variables read:
885     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
886     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
887     # - CSIT_DIR - Path to existing root of local CSIT git repository.
888     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
889     # Variables set:
890     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
891     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
892     # Functions called:
893     # - die - Print to stderr and exit.
894
895     set -exuo pipefail
896
897     case_text="${NODENESS}_${FLAVOR}"
898     case "${case_text}" in
899         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
900         # TODO: Double link availability depends on NIC used.
901         "1n_vbox")
902             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
903             TOPOLOGIES_TAGS="2_node_single_link_topo"
904             ;;
905         "1n_skx" | "1n_tx2")
906             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
907             TOPOLOGIES_TAGS="2_node_single_link_topo"
908             ;;
909         "2n_skx")
910             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
911             TOPOLOGIES_TAGS="2_node_*_link_topo"
912             ;;
913         "3n_skx")
914             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
915             TOPOLOGIES_TAGS="3_node_*_link_topo"
916             ;;
917         "2n_dnv")
918             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
919             TOPOLOGIES_TAGS="2_node_single_link_topo"
920             ;;
921         "3n_dnv")
922             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
923             TOPOLOGIES_TAGS="3_node_single_link_topo"
924             ;;
925         "3n_hsw")
926             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
927             TOPOLOGIES_TAGS="3_node_single_link_topo"
928             ;;
929         "3n_tsh")
930             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
931             TOPOLOGIES_TAGS="3_node_*_link_topo"
932             ;;
933         *)
934             # No falling back to 3n_hsw default, that should have been done
935             # by the function which has set NODENESS and FLAVOR.
936             die "Unknown specification: ${case_text}"
937     esac
938
939     if [[ -z "${TOPOLOGIES-}" ]]; then
940         die "No applicable topology found!"
941     fi
942 }
943
944
945 function untrap_and_unreserve_testbed () {
946
947     # Use this as a trap function to ensure testbed does not remain reserved.
948     # Perhaps call directly before script exit, to free testbed for other jobs.
949     # This function is smart enough to avoid multiple unreservations (so safe).
950     # Topo cleanup is executed (call it best practice), ignoring failures.
951     #
952     # Hardcoded values:
953     # - default message to die with if testbed might remain reserved.
954     # Arguments:
955     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
956     # Variables read (by inner function):
957     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
958     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
959     # Variables written:
960     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
961     # Trap unregistered:
962     # - EXIT - Failure to untrap is reported, but ignored otherwise.
963     # Functions called:
964     # - die - Print to stderr and exit.
965
966     set -xo pipefail
967     set +eu  # We do not want to exit early in a "teardown" function.
968     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
969     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
970     if [[ -z "${wt-}" ]]; then
971         set -eu
972         warn "Testbed looks unreserved already. Trap removal failed before?"
973     else
974         cleanup_topo || true
975         python "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
976             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
977         }
978         WORKING_TOPOLOGY=""
979         set -eu
980     fi
981 }
982
983
984 function warn () {
985
986     # Print the message to standard error.
987     #
988     # Arguments:
989     # - ${@} - The text of the message.
990
991     set -exuo pipefail
992
993     echo "$@" >&2
994 }